// Generated by gtkmmproc -- DO NOT MODIFY!


#include <gstreamermm/bin.h>
#include <gstreamermm/private/bin_p.h>

#include <gstreamermm/pad.h>
#include <gst/gstbin.h>
#include <gst/gstutils.h>
#include <stdexcept>

namespace Gst
{

Glib::RefPtr<Bin> Bin::create(const Glib::ustring& name)
{
  GstElement* bin = gst_bin_new(name.c_str());
  return Glib::wrap((GstBin*) bin);
}

Glib::RefPtr<Bin> Bin::add(const Glib::RefPtr<Element>& element)
{
  bool result = gst_bin_add(gobj(), element->gobj());

  if(result)
    return Glib::wrap(gobj(), true);
  else
    throw std::runtime_error("Bin '" + get_name() + "' does not want to accept Element '" + element->get_name() + "'");
}

Glib::RefPtr<Bin> Bin::remove(const Glib::RefPtr<Element>& element)
{
  bool result = gst_bin_remove(gobj(), element->gobj());

  if(result)
    return Glib::RefPtr<Bin>(this);
  else
    throw std::runtime_error("Bin '" + get_name() + "' does not want to remove Element '" + element->get_name() + "'");
}

Glib::RefPtr<Element> Bin::get_by_name(const Glib::ustring& element_name)
{
  GstElement* element = gst_bin_get_by_name(gobj(), element_name.c_str());

  if(element != NULL)
    return Glib::wrap(element, false);
  else
    throw std::runtime_error("Bin '" + get_name() + "' contains no Element '" + element_name + "'");
}

Glib::RefPtr<Element> Bin::get_by_name_recurse_up(const Glib::ustring& element_name)
{
  GstElement* element = gst_bin_get_by_name_recurse_up(gobj(), element_name.c_str());

  if(element != NULL)
    return Glib::wrap(element, false);
  else
    throw std::runtime_error("Bin '" + get_name() + "' contains no Element '" + element_name + "'");
}

Glib::RefPtr<Pad> Bin::find_unconnected_pad(PadDirection direction)
{
  GstPad* pad = gst_bin_find_unconnected_pad(gobj(), GstPadDirection(direction));

  if(pad != NULL)
    return Glib::wrap(pad, false);
  else
    throw std::runtime_error("Bin '" + get_name() + "' contains no unconnected Pad(s)");
}

} //namespace Gst

namespace
{
} // anonymous namespace


namespace Glib
{

Glib::RefPtr<Gst::Bin> wrap(GstBin* object, bool take_copy)
{
  return Glib::RefPtr<Gst::Bin>( dynamic_cast<Gst::Bin*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Gst
{


/* The *_Class implementation: */

const Glib::Class& Bin_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &Bin_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(gst_bin_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:

  }

  return *this;
}

void Bin_Class::class_init_function(void* g_class, void* class_data)
{
  BaseClassType *const klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
}

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


Glib::ObjectBase* Bin_Class::wrap_new(GObject* object)
{
  return new Bin((GstBin*)object);
}


/* The implementation: */

GstBin* Bin::gobj_copy()
{
  reference();
  return gobj();
}

Bin::Bin(const Glib::ConstructParams& construct_params)
:
  Element(construct_params)
{

}

Bin::Bin(GstBin* castitem)
:
  Element((GstElement*)(castitem))
{}

Bin::~Bin()
{}


Bin::CppClassType Bin::bin_class_; // initialize static member

GType Bin::get_type()
{
  return bin_class_.init().get_type();
}

GType Bin::get_base_type()
{
  return gst_bin_get_type();
}


Bin::Bin()
:
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Element(Glib::ConstructParams(bin_class_.init()))
{
  

}

Glib::RefPtr<Element> Bin::get_by_interface(GType interface)
{
  return Glib::wrap(gst_bin_get_by_interface(gobj(), interface));
}


#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED


} // namespace Gst


